package de.ugoe.cs.quest.eventcore.guimodel;

import de.ugoe.cs.quest.eventcore.IEventTarget;

/**
 * <p>
 * TODO comment
 * </p>
 * 
 * @version $Revision: $ $Date: $
 * @author 2011, last modified by $Author: $
 */
public interface IGUIElement extends IEventTarget {
    
    /**
     * <p>
     * TODO comment
     * </p>
     */
    public IGUIElementSpec getSpecification();

    /**
     * <p>
     * TODO comment
     * </p>
     */
    public IGUIElement getParent();

    /**
     * <p>
     * TODO comment
     * </p>
     *  
     * @param other
     * @return
     */
    public boolean equals(Object other);

    /**
     * <p>
     * TODO comment
     * </p>
     */
    public int hashCode();

    /**
     * <p>
     * TODO comment
     * </p>
     */
    public void updateSpecification(IGUIElementSpec furtherSpec);

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @param guiElement
     */
    public void addEqualGUIElement(IGUIElement equalElement);
}
